#include "Betriebssystem.h"

namespace Framework
{
    template<typename T>
    class RCPointer
    {
    private:
        T *pointer;

    public:
        RCPointer( T *pointer )
        {
            this->pointer = pointer;
        }

        RCPointer( RCPointer &ptr )
        {
            this->pointer = ptr.pointer ? dynamic_cast<T *>( ptr.pointer->getThis() ) : 0;
        }

        ~RCPointer()
        {
            this->pointer->release();
        }

        RCPointer &operator=( RCPointer &ptr )
        {
            if( this->pointer )
                this->pointer->release();
            this->pointer = ptr.pointer ? dynamic_cast<T *>( ptr.pointer->getThis() ) : 0;
        }

        RCPointer &operator=( T *ptr )
        {
            if( this->pointer )
                this->pointer->release();
            this->pointer = ptr;
        }

        T *operator->()
        {
            return pointer;
        }

        operator T *( )
        {
            return pointer;
        }
    };
}